Index: LMDZ5/branches/testing/libf/phylmd/Dust/read_surface.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/read_surface.F90	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/read_surface.F90	(revision 2641)
@@ -0,0 +1,164 @@
+       subroutine read_surface(name,surfa)
+
+     
+! common
+! ------
+       USE ioipsl
+!       USE comgeomphy
+       USE dimphy
+       USE mod_grid_phy_lmdz
+       USE mod_phys_lmdz_para
+       USE iophy
+!       USE netcdf
+       IMPLICIT NONE
+
+       include "netcdf.inc"
+#include "dimensions.h"
+#include "paramet.h"
+
+       character*10 name
+       character*10 varname
+!
+       real tmp_dyn(iip1,jjp1)
+       real tmp_dyn_glo(nbp_lon+1,nbp_lat)
+!       real tmp_dyn_glo(nbp_lon,nbp_lat)
+       REAL tmp_dyn_invers(iip1,jjp1)
+       real tmp_dyn_invers_glo(nbp_lon+1,nbp_lat)
+!       real tmp_dyn_invers_glo(nbp_lon,nbp_lat)
+       real tmp_fi(klon)
+       real tmp_fi_glo(klon_glo)
+       real surfa(klon,5)
+       real surfa_glo(klon_glo,5)
+!
+       integer ncid
+       integer varid
+       real rcode
+       integer start(2),count(2),status
+       integer i,j,l,ig
+       character*1 str1
+
+!JE20140526<<
+      character*4 ::  latstr,aux4s
+      logical :: outcycle, isinversed
+      real, dimension(jjp1) :: lats
+      real, dimension(nbp_lat) :: lats_glo
+      real :: rcode2
+      integer, dimension(1) :: startj,endj
+!JE20140526>>
+!$OMP MASTER
+       IF (is_mpi_root .AND. is_omp_root) THEN
+
+       print*,'Lecture du fichier donnees_lisa.nc' 
+       ncid=NCOPN('donnees_lisa.nc',NCNOWRIT,rcode)
+
+!JE20140526<<: check if are inversed or not the latitude grid in donnes_lisa
+      outcycle=.false.
+      latstr='null'
+      isinversed=.false.
+      do i=1,5
+       if (i==1) aux4s='latu'
+       if (i==2) aux4s='LATU'
+       if (i==3) aux4s='LatU'
+       if (i==4) aux4s='Latu'
+       if (i==5) aux4s='latU'
+       status = NF_INQ_VARID (ncid, aux4s, rcode)
+!       print *,'stat,i',status,i,outcycle,aux4s
+!       print *,'ifclause',status.NE. NF_NOERR ,outcycle == .false.
+       IF ((.not.(status.NE. NF_NOERR) ).and.( .not. outcycle )) THEN
+         outcycle=.true.
+         latstr=aux4s
+       ENDIF
+      enddo ! check if it inversed lat
+      startj(1)=1
+!      endj(1)=jjp1
+      endj(1)=nbp_lat
+      varid=NCVID(ncid,latstr,rcode)
+
+#ifdef NC_DOUBLE
+          status=NF_GET_VARA_DOUBLE(ncid,varid,startj,endj,lats_glo)
+#else
+          status=NF_GET_VARA_REAL(ncid,varid,startj,endj,lats_glo)
+#endif
+!      print *,latstr,varid,status,jjp1,rcode
+!      IF (status .NE. NF_NOERR) print*,'NOOOOOOO'
+!      print *,lats
+!stop
+
+! check if netcdf is latitude inversed or not. 
+      if (lats_glo(1)<lats_glo(2)) isinversed=.true.
+! JE20140526>>
+
+
+       DO i=1,5
+          write(str1,'(i1)') i
+          varname=trim(name)//str1
+       print*,'lecture variable:',varname
+          varid=NCVID(ncid,trim(varname),rcode)
+!          varid=NCVID(ncid,varname,rcode)
+
+!  dimensions pour les champs scalaires et le vent zonal
+!  -----------------------------------------------------
+
+          start(1)=1
+          start(2)=1      
+          count(1)=nbp_lon+1
+!          count(1)=iip1
+          count(2)=nbp_lat
+!          count(2)=jjp1
+
+! mise a zero des tableaux 
+! ------------------------
+          tmp_dyn(:,:)=0.0
+          tmp_fi(:)=0.0
+! Lecture
+! -----------------------
+#ifdef NC_DOUBLE
+          status=NF_GET_VARA_DOUBLE(ncid,varid,start,count,tmp_dyn_glo)
+#else
+          status=NF_GET_VARA_REAL(ncid,varid,start,count,tmp_dyn_glo)
+#endif
+
+!      call dump2d(iip1,jjp1,tmp_dyn,'tmp_dyn   ')
+       DO j=1, nbp_lat
+          DO ig=1, nbp_lon+1
+             tmp_dyn_invers_glo(ig,j)=tmp_dyn_glo(ig,nbp_lat-j+1)
+          ENDDO
+       ENDDO
+
+       
+!JE20140522!          call gr_dyn_fi_p(1, iip1, jjp1, klon, tmp_dyn_invers, tmp_fi)
+
+!JE20140526<<
+!              call gr_dyn_fi(1, iip1, jjp1, klon, tmp_dyn_invers, tmp_fi)
+           if (isinversed) then
+                        call gr_dyn_fi(1, nbp_lon+1, nbp_lat, klon_glo, &
+     & tmp_dyn_invers_glo, tmp_fi_glo)
+!              call gr_dyn_fi(1, iip1, jjp1, klon, tmp_dyn_invers, tmp_fi)
+!              call gr_dyn_fi_p(1, iip1, jjp1, klon, tmp_dyn_invers, tmp_fi)
+           else      
+                        call gr_dyn_fi(1, nbp_lon+1, nbp_lat, klon_glo, &
+     &   tmp_dyn_glo, tmp_fi_glo)
+!              call gr_dyn_fi(1, iip1, jjp1, klon, tmp_dyn, tmp_fi)
+!              call gr_dyn_fi_p(1, iip1, jjp1, klon, tmp_dyn, tmp_fi)
+           endif
+!JE20140526>>
+!      call dump2d(iim,jjm-1,tmp_fi(2),'tmp_fi   ')
+!
+          DO j=1,klon_glo
+
+                surfa_glo(j,i)=tmp_fi_glo(j)
+
+          ENDDO ! Fin de recopie du tableau
+!
+       ENDDO ! Fin boucle 1 a 5
+       print*,'Passage Grille Dyn -> Phys'
+
+
+      ENDIF !mpi 
+!$OMP END MASTER
+!$OMP BARRIER
+      call scatter(surfa_glo,surfa)
+
+
+       return
+       end subroutine read_surface
Index: LMDZ5/branches/testing/libf/phylmd/Dust/read_vent.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/read_vent.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/read_vent.F	(revision 2641)
@@ -0,0 +1,145 @@
+      SUBROUTINE read_vent(debutphy, step, nbjour, u10m_ec, v10m_ec)
+      USE dimphy
+      USE mod_grid_phy_lmdz
+      USE mod_phys_lmdz_para
+!      USE write_field_phy
+      IMPLICIT NONE 
+#include "dimensions.h"
+c #include "dimphy.h"
+#include "paramet.h"
+#include "netcdf.inc"
+c
+      INTEGER step, nbjour
+      LOGICAL debutphy
+      real u10m_ec(klon), v10m_ec(klon)
+      real u10m_ec_glo(klon_glo), v10m_ec_glo(klon_glo)
+c
+!      real u10m_nc(iip1,jjp1) !, v10m_nc(iip1,jjm) ! dim 97x72
+!      real v10m_nc(iip1,jjp1)  ! dim 97x73
+      real u10m_nc_glo(nbp_lon+1,nbp_lat) !, v10m_nc(iip1,jjm) ! dim 97x72
+      real v10m_nc_glo(nbp_lon+1,nbp_lat)  ! dim 97x73
+      real rcode
+      integer ncidu1, varidu1, ncidv1, varidv1
+      save ncidu1, varidu1, ncidv1, varidv1
+!$OMP THREADPRIVATE(ncidu1, varidu1, ncidv1, varidv1)
+      integer start(4),count(4), status
+      integer i, j, ig
+
+
+c
+!$OMP MASTER
+      IF (is_mpi_root .AND. is_omp_root) THEN
+      if (debutphy) then
+c
+         ncidu1=NCOPN('u10m.nc',NCNOWRIT,rcode)
+         varidu1=NCVID(ncidu1,'UWND',rcode)
+         ncidv1=NCOPN('v10m.nc',NCNOWRIT,rcode)
+         varidv1=NCVID(ncidv1,'VWND',rcode)
+c
+      endif
+c
+      start(1)=1
+      start(2)=1
+      start(4)=0
+
+!      count(1)=iip1
+      count(1)=nbp_lon+1
+!      count(2)=jjp1
+      count(2)=nbp_lat
+      count(3)=1
+      count(4)=0
+c
+      start(3)=step
+c
+#ifdef NC_DOUBLE
+!      status=NF_GET_VARA_DOUBLE(ncidu1,varidu1,start,count,u10m_nc)
+      status=NF_GET_VARA_DOUBLE(ncidu1,varidu1,start,count,u10m_nc_glo)
+#else
+!      status=NF_GET_VARA_REAL(ncidu1,varidu1,start,count,u10m_nc)
+      status=NF_GET_VARA_REAL(ncidu1,varidu1,start,count,u10m_nc_glo)
+#endif
+!       print *,status
+c
+#ifdef NC_DOUBLE
+!      status=NF_GET_VARA_DOUBLE(ncidv1,varidv1,start,count,v10m_nc)
+      status=NF_GET_VARA_DOUBLE(ncidv1,varidv1,start,count,v10m_nc_glo)
+#else
+!      status=NF_GET_VARA_REAL(ncidv1,varidv1,start,count,v10m_nc)
+      status=NF_GET_VARA_REAL(ncidv1,varidv1,start,count,v10m_nc_glo)
+#endif
+c
+
+!      print *,'beforebidcor u10m_nc', u10m_nc(1,jjp1)
+!      print *,'beforebidcor v10m_nc', v10m_nc(1,jjp1)
+
+!       print *,status
+!      call correctbid(iim,jjp1,u10m_nc)
+!      call correctbid(iim,jjp1,v10m_nc)
+      call correctbid(nbp_lon,nbp_lat,u10m_nc_glo)
+      call correctbid(nbp_lon,nbp_lat,v10m_nc_glo)
+
+!      print *,'afterbidcor u10m_nc', u10m_nc(1,jjp1)
+!      print *,'afterbidcor v10m_nc', v10m_nc(1,jjp1)
+c
+c--upside down + physical grid
+c
+!      u10m_ec(1)=u10m_nc(1,jjp1)
+!      v10m_ec(1)=v10m_nc(1,jjp1)
+      u10m_ec_glo(1)=u10m_nc_glo(1,nbp_lat)
+      v10m_ec_glo(1)=v10m_nc_glo(1,nbp_lat)
+      ig=2
+!      DO j=2,jjm
+!         DO i = 1, iim
+      DO j=2,nbp_lat-1
+         DO i = 1, nbp_lon
+!           u10m_ec(ig)=u10m_nc(i,jjp1+1-j)
+!           v10m_ec(ig)=v10m_nc(i,jjp1+1-j)
+           u10m_ec_glo(ig)=u10m_nc_glo(i,nbp_lat+1-j)
+           v10m_ec_glo(ig)=v10m_nc_glo(i,nbp_lat+1-j)
+           ig=ig+1
+!         print *,u10m_ec(ig) ,v10m_ec(ig) 
+         ENDDO
+      ENDDO
+      u10m_ec_glo(ig)=u10m_nc_glo(1,1)
+      v10m_ec_glo(ig)=v10m_nc_glo(1,1)
+
+
+!      end if master
+      ENDIF 
+!$OMP END MASTER
+!$OMP BARRIER
+      CALL scatter(u10m_ec_glo,u10m_ec)
+      CALL scatter(v10m_ec_glo,v10m_ec)
+
+!      print *,'JE  tamagno viento ig= ', ig
+!      print *,'READ_VENT U = ',SUM(u10m_ec),MINVAL(u10m_ec),
+!     .                                      MAXVAL(u10m_ec)
+!      print *,'READ_VENT V = ',SUM(v10m_ec),MINVAL(v10m_ec),
+!     .                                      MAXVAL(v10m_ec)
+!       print *,'u v 1 ', u10m_ec(1),v10m_ec(1)
+!       print *,'u v klon ', u10m_ec(klon),v10m_ec(klon)
+      RETURN 
+      END
+
+c added by JE from the nh SPLA, dyn3d/read_reanalyse.F which is not available any more
+      subroutine correctbid(iim,nl,x)
+      integer iim,nl
+      real x(iim+1,nl)
+      integer i,l
+      real zz
+
+      do l=1,nl
+         do i=2,iim-1
+            if(abs(x(i,l)).gt.1.e10) then
+               zz=0.5*(x(i-1,l)+x(i+1,l))
+c              print*,'correction ',i,l,x(i,l),zz
+               x(i,l)=zz
+            endif
+         enddo
+      enddo
+
+      return
+      end
+
+
+
Index: LMDZ5/branches/testing/libf/phylmd/Dust/satellite_out_spla.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/satellite_out_spla.F90	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/satellite_out_spla.F90	(revision 2641)
@@ -0,0 +1,192 @@
+
+SUBROUTINE satellite_out_spla(jD_cur,jH_cur,pdtphys,rlat,rlon, &
+                              masque_aqua, masque_terra )
+
+  USE dimphy
+  USE IOIPSL
+  USE write_field_phy
+
+  IMPLICIT NONE
+
+  REAL :: pdtphys, jD_cur,jH_cur, hour
+  INTEGER :: year_cur, mth_cur, day_cur
+  INTEGER :: masque_polder(klon)  ! masque polder
+  INTEGER :: masque_aqua(klon)  ! masque polder
+  INTEGER :: masque_terra(klon)  ! masque polder
+  INTEGER :: i
+  REAL :: overpassaqua, overpassterra
+  REAL,dimension(klon) :: rlat,rlon
+
+
+  masque_polder(:) = 0.
+
+  CALL ju2ymds(jD_cur+jH_cur, year_cur, mth_cur, day_cur, hour)
+!  print*,'JDcur=',jD_cur,'JHcur=',jH_cur,'year_cur' ,year_cur,'mth_cur' ,mth_cur, 'day_cur',day_cur,'hour' ,hour
+
+!  IF ( (year_cur*100.+mth_cur .GE. 199611 ) .AND. (year_cur*100.+mth_cur .LE. 199706)) THEN 
+!          CALL swathpolder(year_cur,mth_cur,day_cur,hour/86400., &
+!            pdtphys,rlon,rlat,masque_polder)
+!  ENDIF
+!
+!  DO i=1,klon
+!    IF ( masque_polder(i) .EQ. 1 ) THEN
+!        print *,'polder output point, lon:', rlon(i),', lat: ',rlat(i)
+!    ENDIF
+!  ENDDO
+!  CALL writefield_phy("masque_polder",float(masque_polder),1)
+
+! Aqua
+  masque_aqua(:) = 0.
+  overpassaqua=48600.  ! 13.30 p.m. local time
+  CALL swathpolarsat(year_cur,mth_cur,day_cur,hour, &
+            pdtphys,rlon,rlat,overpassaqua,masque_aqua)
+
+!  DO i=1,klon
+!    IF ( masque_aqua(i) .EQ. 1 ) THEN
+!        print *,'aqua output point, lon:', rlon(i),', lat: ',rlat(i)
+!    ENDIF
+!  ENDDO
+!  CALL writefield_phy("masque_aqua",float(masque_aqua),1)
+
+  masque_terra(:) = 0.
+  overpassterra=37800.  ! 10.30 a.m. local time
+  CALL swathpolarsat(year_cur,mth_cur,day_cur,hour, &
+            pdtphys,rlon,rlat,overpassterra,masque_terra)
+
+!  DO i=1,klon
+!    IF ( masque_terra(i) .EQ. 1 ) THEN
+!        print *,'terra output point, lon:', rlon(i),', lat: ',rlat(i)
+!    ENDIF
+!  ENDDO
+!  CALL writefield_phy("masque_terra",float(masque_terra),1)
+
+  RETURN
+END SUBROUTINE satellite_out_spla
+
+
+
+
+SUBROUTINE swathpolarsat(annee,mois,jour,heure,pdtphys, &
+     rlon,rlat,overpasstime,masque)
+  ! Adaptation from the simple satellite simulator of AeroCom working group Indirect
+  ! forcing ( Johannes Quaas, MPI for Meteorology, Hamburg )
+  ! http://wiki.esipfed.org/index.php/Indirect_forcing
+  
+  USE dimphy
+  IMPLICIT NONE
+
+  INTEGER :: annee, mois, jour, i
+  REAL :: heure                      !--heure en jour
+  REAL :: pdtphys                    !--pas de temps en seconde
+  REAL :: rlon(1:klon), rlat(1:klon) !--longitude et latitude
+  INTEGER :: masque(1:klon)
+  REAL :: localtime(1:klon)
+  REAL :: overpasstime, utctime
+
+  masque(:) = 0
+  utctime=heure
+  DO i=1,klon
+        localtime(i) = utctime + 240. * rlon(i) ! for each degree of longitude east,4 min earlier local time
+!        IF ( localtime(i) > 86400. ) THEN ! this is still the previous day
+!                localtime(i) = localtime(i) - 86400.
+!        ENDIF
+        ! Select 10.30 a.m. ± dt/2
+!       IF ( ABS( localtime(i) - overpasstime ) <= pdtphys/2. ) THEN 
+        IF ( ABS(MOD(localtime(i)+86400.*100,86400.) - overpasstime ) <= pdtphys/2. ) THEN 
+                masque(i) = 1
+        ENDIF
+   ENDDO
+
+
+END SUBROUTINE swathpolarsat
+
+SUBROUTINE swathpolder(annee,mois,jour,heure,pdtphys, &
+     rlon,rlat,masque)
+!  Adapted from INCA
+
+!  USE inca_dim
+  USE dimphy
+  IMPLICIT NONE
+
+  !--Auteurs : Francois-Marie Breon + Olivier Boucher
+
+  !-- adapted to be used in INCA aerosol module Michael Schulz
+
+  ! not needed?
+
+  INTEGER :: annee, mois, jour 
+  REAL :: heure                      !--heure en jour
+  REAL :: pdtphys                    !--pas de temps en seconde
+  REAL :: rlon(1:klon), rlat(1:klon) !--longitude et latitude
+  INTEGER :: masque(1:klon)
+
+  REAL :: J0              !--origine des temps pour les orbites ADEOS 
+  PARAMETER (J0=183.91267)
+  REAL :: secinday
+  PARAMETER (secinday=86400.)
+  REAL :: duree_orb       !--Duree d une orbite ADEOS en jour 
+  PARAMETER (duree_orb=6055.3715/secinday)
+  REAL :: deltalon        !--Decalage en longitude entre 2 orbites successives
+  PARAMETER (deltalon=41./585.*360.)
+  REAL :: demi_larg_eq    !--demi-largeur d'une orbite a l equateur
+  PARAMETER (demi_larg_eq=11.)
+  REAL :: incli, inclideg
+  PARAMETER (inclideg=98.59)
+  REAL :: RADEG, DTOR, RPI
+  REAL :: demi_periode
+  INTEGER :: jacum(1:12)
+  DATA jacum/0,31,59,90,120,151,181,212,243,273,304,334/
+  INTEGER :: an, orb, i, j
+  REAL :: timepolder, lon0, posnorm, lim_nord, lim_sud
+  REAL :: tempo, lon_cen, demi_larg
+  REAL :: lat_debut, lat_fin, lon_west, lon_east
+  REAL :: zlon            !--rlon mais remis entre 0 et 360
+  REAL :: deltat          !--plage de temps a considerer en jours  
+
+
+  RPI = 4 * atan (1.0)
+  deltat=pdtphys/secinday
+  demi_periode=deltat/2./duree_orb
+  RADEG=180./RPI
+  DTOR=RPI/180.
+  incli=inclideg*DTOR
+
+  an = MOD(annee, 100) 
+  timepolder=FLOAT((an-96)*365+jacum(mois)+jour)+heure
+  orb=INT((timepolder-J0)/duree_orb+0.5) 
+  lon0=360.-MOD(168.02+FLOAT(orb)*deltalon,360.)
+  posnorm=(timepolder-j0)/duree_orb-FLOAT(orb)
+  j=jacum(mois)+jour
+  lim_nord=60.5 + 25.*(1.-COS((FLOAT(J)+10.)/365.*2.*RPI))
+  lim_sud=-53.0 - 20.*(1.+COS(FLOAT(J)/365.*2*RPI))
+  !--lat de debut
+  lat_debut=MIN(MIN(90.,(-posnorm+demi_periode)*360.),lim_nord) 
+  !--lat de fin
+  lat_fin  =MAX(MAX(-90.,(-posnorm-demi_periode)*360.),lim_sud) 
+
+  DO i=1, klon
+     masque(i)=0
+     tempo=ASIN( MAX(-1.,MIN(1., -SIN(rlat(i)*DTOR)/SIN(incli))))
+     lon_cen=(ATAN(TAN(tempo)*COS(incli))-duree_orb*tempo)*RADEG
+     demi_larg=demi_larg_eq/COS(rlat(i)*DTOR)
+     IF (ABS(SIN(rlat(i)*DTOR)/SIN(incli)).GE.1.0) demi_larg=200.0
+     IF (rlat(i).GE.lat_fin.AND.rlat(i).LE.lat_debut) THEN 
+        IF (demi_larg.GE. 180.) THEN 
+           masque(i)=1
+        ELSE  
+           lon_west = MOD(lon0+lon_cen-demi_larg+720., 360.)
+           lon_east = MOD(lon0+lon_cen+demi_larg,      360.)
+           zlon     = MOD(rlon(i)+360.,                360.)
+           IF (lon_west.LE.lon_east) THEN 
+              IF (zlon.GE.lon_west.AND.zlon.LE.lon_east) masque(i)=1
+           ELSE               
+              IF (zlon.GE.lon_west.OR.zlon.LE.lon_east) masque(i)=1
+           ENDIF
+        ENDIF
+     ENDIF
+  ENDDO
+
+  RETURN
+END SUBROUTINE swathpolder
+
+
Index: LMDZ5/branches/testing/libf/phylmd/Dust/seasalt.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/seasalt.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/seasalt.F	(revision 2641)
@@ -0,0 +1,52 @@
+c       This subroutine estimateis Sea Salt emission fluxes over 
+c       Oceanic surfaces.
+c 
+      SUBROUTINE seasalt(v_10m, u_10m, pct_ocean, lmt_sea_salt)
+    
+      USE dimphy
+      IMPLICIT NONE 
+c
+#include "dimensions.h"
+#include "chem.h"
+#include "chem_spla.h"
+#include "YOMCST.h"
+#include "YOECUMF.h"
+c
+      INTEGER i, bin                 !local variables
+      REAL pct_ocean(klon)           !hfraction of Ocean in each grid
+      REAL v_10m(klon), u_10m(klon)  !V&H components of wind @10 m 
+      REAL w_speed_10m(klon)         !wind speed at 10m from surface
+      REAL lmt_sea_salt(klon,ss_bins)!sea salt emission flux - mg/m2/s
+      REAL sea_salt_flux(ss_bins)    !sea salt emission flux per unit wind speed
+
+      REAL wind, ocean
+c
+c------Sea salt emission fluxes for each size bin calculated 
+c------based on on parameterisation of Gong et al. (1997).
+c------Fluxes of sea salt for each size bin are given in mg/m^2/sec
+c------at wind speed of 1 m/s at 10m height (at 80% RH).
+c------Fluxes at various wind speeds (@10 m from sea 
+c------surfaces are estimated using relationship: F=flux*U_10^3.14
+c
+cnhl for size bin of 0.03-0.5 and 0.5-20
+      DATA sea_salt_flux/4.5E-09,8.7E-7/
+
+      DO i=1, klon
+      w_speed_10m(i)= (v_10m(i)**2.0+u_10m(i)**2.0)**0.5
+      ENDDO
+c
+      DO bin=1,ss_bins
+      wind=0.0
+      ocean=0.0
+      DO i=1, klon
+      lmt_sea_salt(i,bin)=sea_salt_flux(bin)*(w_speed_10m(i)**3.41)
+     . *pct_ocean(i)*1.e-4*1.e-3                       !g/cm2/s
+      wind=wind+w_speed_10m(i)
+      ocean=ocean+pct_ocean(i)
+      ENDDO
+!      print *,'Sea Salt flux = ',sea_salt_flux(bin)
+      ENDDO
+!      print *,'SUM OF WIND = ',wind
+!      print *,'SUM OF OCEAN SURFACE = ',ocean
+      RETURN 	
+      END
Index: LMDZ5/branches/testing/libf/phylmd/Dust/sediment_mod.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/sediment_mod.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/sediment_mod.F	(revision 2641)
@@ -0,0 +1,341 @@
+c----- This subroutine calculates the sedimentation flux of Tracers 
+c
+      SUBROUTINE sediment_mod(t_seri,pplay,zrho,paprs,time_step,RHcl,
+     .                                       id_coss,id_codu,id_scdu,
+     .                                        ok_chimeredust,
+     .                           sed_ss,sed_dust,sed_dustsco,
+     .                        sed_ss3D,sed_dust3D,sed_dustsco3D,tr_seri)
+cnhl     .                                       xlon,xlat,
+c
+       USE dimphy
+       USE infotrac
+      IMPLICIT NONE 
+c
+#include "dimensions.h"
+#include "chem.h"
+c #include "dimphy.h"
+#include "YOMCST.h"
+#include "YOECUMF.h"
+c
+       REAL RHcl(klon,klev)     ! humidite relative ciel clair
+       REAL tr_seri(klon, klev,nbtr) !conc of tracers
+       REAL sed_ss(klon) !sedimentation flux of Sea Salt (g/m2/s)
+       REAL sed_dust(klon) !sedimentation flux of dust (g/m2/s)
+       REAL sed_dustsco(klon) !sedimentation flux of scoarse  dust (g/m2/s)
+       REAL sed_ss3D(klon,klev) !sedimentation flux of Sea Salt (g/m2/s)
+       REAL sed_dust3D(klon,klev) !sedimentation flux of dust (g/m2/s)
+       REAL sed_dustsco3D(klon,klev) !sedimentation flux of scoarse  dust (g/m2/s)
+       REAL t_seri(klon, klev)   !Temperature at mid points of Z (K)
+       REAL v_dep_ss(klon,klev)  ! sed. velocity for SS m/s
+       REAL v_dep_dust(klon,klev)  ! sed. velocity for dust m/s
+       REAL v_dep_dustsco(klon,klev)  ! sed. velocity for dust m/s
+       REAL pplay(klon, klev)    !pressure at mid points of Z (Pa)
+       REAL zrho(klon, klev)     !Density of air at mid points of Z (kg/m3)
+       REAL paprs(klon, klev+1)    !pressure at interface of layers Z (Pa)
+       REAL time_step            !time step (sec)
+       LOGICAL ok_chimeredust
+       REAL xlat(klon)       ! latitudes pour chaque point 
+       REAL xlon(klon)       ! longitudes pour chaque point 
+       INTEGER id_coss,id_codu,id_scdu
+c
+c------local variables
+c 
+       INTEGER i, k, nbre_RH
+       PARAMETER(nbre_RH=12)
+c
+       REAL lambda, ss_g            
+       REAL mmd_ss      !mass median diameter of SS (um) 
+       REAL mmd_dust          !mass median diameter of dust (um) 
+       REAL mmd_dustsco          !mass median diameter of scoarse dust (um) 
+       REAL rho_ss(nbre_RH),rho_ss1 !density of sea salt (kg/m3)
+       REAL rho_dust          !density of dust(kg/m3)
+       REAL v_stokes, CC, v_sed, ss_growth_f(nbre_RH)
+       REAL sed_flux(klon,klev)  ! sedimentation flux g/m2/s
+       REAL air_visco(klon,klev)
+       REAL zdz(klon,klev)       ! layers height (m)
+       REAL temp                 ! temperature in degree Celius 
+c
+       INTEGER RH_num
+       REAL RH_MAX, DELTA, rh, RH_tab(nbre_RH)
+       PARAMETER (RH_MAX=95.)
+c
+       DATA RH_tab/0.,10.,20.,30.,40.,50.,60.,70.,80.,85.,90.,95./
+c
+c
+       DATA rho_ss/2160. ,2160. ,2160.,  2160,  1451.6, 1367.9,
+     .             1302.9,1243.2,1182.7, 1149.5,1111.6, 1063.1/
+c
+       DATA ss_growth_f/0.503, 0.503, 0.503, 0.503, 0.724, 0.782, 
+     .                  0.838, 0.905, 1.000, 1.072, 1.188, 1.447/
+c
+c
+       mmd_ss=12.7   !dia -um at 80% for bin 0.5-20 um but 90% of real mmd
+!               obsolete      mmd_dust=2.8  !micrometer for bin 0.5-20 and 0.5-10 um
+! 4tracer SPLA:       mmd_dust=11.0  !micrometer for bin 0.5-20 and 0.5-10 um
+!3days       mmd_dust=3.333464  !micrometer for bin 0.5-20 and 0.5-10 um
+!3days       mmd_dustsco=12.91315  !micrometer for bin 0.5-20 and 0.5-10 um
+!JE20140911       mmd_dust=3.002283  !micrometer for bin 0.5-20 and 0.5-10 um
+!JE20140911       mmd_dustsco=13.09771  !micrometer for bin 0.5-20 and 0.5-10 um
+!JE20140911        mmd_dust=5.156346  !micrometer for bin 0.5-20 and 0.5-10 um
+!JE20140911        mmd_dustsco=15.56554  !micrometer for bin 0.5-20 and 0.5-10 um
+        IF (ok_chimeredust) THEN 
+!JE20150212<< : changes in ustar in dustmod changes emission distribution
+!        mmd_dust=3.761212  !micrometer for bin 0.5-3 and 0.5-10 um
+!        mmd_dustsco=15.06167  !micrometer for bin 3-20 and 0.5-10 um
+!JE20150212>>
+!JE20150618: Change in div3 of dustmod changes distribution. now is div3=6
+!div=3        mmd_dust=3.983763
+!div=3        mmd_dustsco=15.10854 
+        mmd_dust=3.898047
+        mmd_dustsco=15.06167 
+        ELSE 
+        mmd_dust=11.0  !micrometer for bin 0.5-20 and 0.5-10 um
+        mmd_dustsco=100. ! absurd value, bin not used in this scheme
+        ENDIF
+
+
+       rho_dust=2600. !kg/m3
+c
+c--------- Air viscosity (poise=0.1 kg/m-sec)-----------
+c
+       DO k=1, klev
+       DO i=1, klon
+c
+       zdz(i,k)=(paprs(i,k)-paprs(i,k+1))/zrho(i,k)/RG
+c
+       temp=t_seri(i,k)-RTT
+c
+       IF (temp.LT.0.) THEN
+         air_visco(i,k)=(1.718+0.0049*temp-1.2e-5*temp*temp)*1.e-4 
+       ELSE
+         air_visco(i,k)=(1.718+0.0049*temp)*1.e-4 
+       ENDIF
+c
+       ENDDO
+       ENDDO
+c
+c--------- for Sea Salt -------------------
+c
+c
+c
+       IF(id_coss>0) THEN
+       DO k=1, klev
+       DO i=1,klon
+c
+c---cal. correction factor hygroscopic growth of aerosols
+c
+        rh=MIN(RHcl(i,k)*100.,RH_MAX)
+        RH_num = INT( rh/10. + 1.)
+        IF (rh.gt.85.) RH_num=10
+        IF (rh.gt.90.) RH_num=11
+        DELTA=(rh-RH_tab(RH_num))/(RH_tab(RH_num+1)-RH_tab(RH_num))
+c
+        ss_g=ss_growth_f(rh_num) +
+     .       DELTA*(ss_growth_f(RH_num+1)-ss_growth_f(RH_num))
+
+        rho_ss1=rho_ss(rh_num) +
+     .       DELTA*(rho_ss(RH_num+1)-rho_ss(RH_num))              
+c
+        v_stokes=RG*(rho_ss1-zrho(i,k))*      !m/sec
+     .           (mmd_ss*ss_g)*(mmd_ss*ss_g)*
+     .           1.e-12/(18.0*air_visco(i,k)/10.)
+c
+       lambda=6.6*1.e-8*(103125/pplay(i,k))*(t_seri(i,k)/293.15)
+c
+       CC=1.0+1.257*lambda/(mmd_ss*ss_g)/1.e6  ! C-correction factor 
+c
+       v_sed=v_stokes*CC                       ! m/sec !orig
+c
+c---------check for v_sed*dt<zdz
+c
+       IF (v_sed*time_step.GT.zdz(i,k)) THEN
+         v_sed=zdz(i,k)/time_step      
+       ENDIF
+c
+       v_dep_ss(i,k)= v_sed
+       sed_flux(i,k)= tr_seri(i,k,id_coss)*v_sed !g/cm3*m/sec
+       !sed_ss3D(i,k)= -sed_flux(i,k)/zdz(i,k)      !g/cm3*sec !!!!!!!
+      ! conc_sed_ss3D(i,k)=sed_flux(i,k)*1.e6      !g/m3*sec !!!!!!!
+c
+       ENDDO          !klon
+       ENDDO          !klev
+c
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+       sed_ss3D(:,:)=0.0  ! initialisation 
+      
+       DO k=1, klev
+       DO i=1, klon
+       sed_ss3D(i,k)=sed_ss3D(i,k)-
+     .        sed_flux(i,k)/zdz(i,k) !!!!!!!!!!!!!!!!!!!!!!
+       ENDDO          !klon
+       ENDDO          !klev
+c
+       DO k=1, klev-1
+       DO i=1, klon
+        sed_ss3D(i,k)=sed_ss3D(i,k)+                   
+     .                  sed_flux(i,k+1)/zdz(i,k) !!!!!!!!
+
+       ENDDO          !klon
+       ENDDO          !klev
+
+      DO k = 1, klev
+      DO i = 1, klon
+          tr_seri(i,k,id_coss)=tr_seri(i,k,id_coss)+
+     s   sed_ss3D(i,k)*time_step
+      ENDDO
+      ENDDO
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+c
+       DO i=1, klon
+         sed_ss(i)=sed_flux(i,1)*1.e6*1.e3    !--unit mg/m2/s
+       ENDDO          !klon
+       ELSE
+        DO i=1, klon
+          sed_ss(i)=0.
+        ENDDO
+       ENDIF
+c
+c
+
+c--------- For dust ------------------
+c
+c
+       IF(id_codu>0) THEN
+       DO k=1, klev
+       DO i=1,klon
+c
+        v_stokes=RG*(rho_dust-zrho(i,k))*      !m/sec
+     .           mmd_dust*mmd_dust*
+     .           1.e-12/(18.0*air_visco(i,k)/10.)
+c
+       lambda=6.6*1.e-8*(103125/pplay(i,k))*(t_seri(i,k)/293.15)
+       CC=1.0+1.257*lambda/(mmd_dust)/1.e6        !dimensionless
+       v_sed=v_stokes*CC                       !m/sec
+c
+c---------check for v_sed*dt<zdz
+c
+       IF (v_sed*time_step.GT.zdz(i,k)) THEN
+         v_sed=zdz(i,k)/time_step      
+       ENDIF
+
+c
+       v_dep_dust(i,k)= v_sed
+       sed_flux(i,k)  = tr_seri(i,k,id_codu)*v_sed !g/cm3.m/sec
+       !sed_dust3D(i,k)= -sed_flux(i,k)/zdz(i,k)      !g/cm3*sec !!!!!!!
+c
+       ENDDO          !klon
+       ENDDO          !klev
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+       sed_dust3D(:,:)=0.0  ! initialisation 
+
+       DO k=1, klev
+       DO i=1, klon
+       sed_dust3D(i,k)=sed_dust3D(i,k)-
+     .                  sed_flux(i,k)/zdz(i,k)
+       ENDDO          !klon
+       ENDDO          !klev
+
+c
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+       
+       DO k=1, klev-1
+       DO i=1, klon
+        sed_dust3D(i,k)=sed_dust3D(i,k) +
+     .                  sed_flux(i,k+1)/zdz(i,k)
+       ENDDO          !klon
+       ENDDO          !klev
+c
+      DO k = 1, klev
+      DO i = 1, klon
+         tr_seri(i,k,id_codu)=tr_seri(i,k,id_codu)+
+     s    sed_dust3D(i,k)*time_step
+      ENDDO
+      ENDDO
+
+
+       DO i=1, klon
+         sed_dust(i)=sed_flux(i,1)*1.e6*1.e3    !--unit mg/m2/s
+       ENDDO          !klon
+       ELSE
+        DO i=1, klon
+          sed_dust(i)=0.
+        ENDDO
+       ENDIF
+c
+
+
+c--------- For scoarse  dust ------------------
+c
+c
+       IF(id_scdu>0) THEN
+       DO k=1, klev
+       DO i=1,klon
+c
+        v_stokes=RG*(rho_dust-zrho(i,k))*      !m/sec
+     .           mmd_dustsco*mmd_dustsco*
+     .           1.e-12/(18.0*air_visco(i,k)/10.)
+c
+       lambda=6.6*1.e-8*(103125/pplay(i,k))*(t_seri(i,k)/293.15)
+       CC=1.0+1.257*lambda/(mmd_dustsco)/1.e6        !dimensionless
+       v_sed=v_stokes*CC                       !m/sec
+c
+c---------check for v_sed*dt<zdz
+
+
+       IF (v_sed*time_step.GT.zdz(i,k)) THEN
+         v_sed=zdz(i,k)/time_step
+       ENDIF
+
+c
+       v_dep_dustsco(i,k)= v_sed
+       sed_flux(i,k)     = tr_seri(i,k,id_scdu)*v_sed !g/cm3.m/sec
+       !sed_dustsco3D(i,k)= -sed_flux(i,k)/zdz(i,k)      !g/cm3*sec !!!!!!!
+c
+       ENDDO          !klon
+       ENDDO          !klev
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+       sed_dustsco3D(:,:)=0.0  ! initialisation 
+
+       DO k=1, klev
+       DO i=1, klon
+       sed_dustsco3D(i,k)=sed_dustsco3D(i,k)-
+     .                  sed_flux(i,k)/zdz(i,k)
+       ENDDO          !klon
+       ENDDO          !klev
+c
+       DO k=1, klev-1
+       DO i=1, klon
+        sed_dustsco3D(i,k)=sed_dustsco3D(i,k) +
+     .                  sed_flux(i,k+1)/zdz(i,k)
+       ENDDO          !klon
+       ENDDO          !klev
+
+      DO k = 1, klev
+      DO i = 1, klon
+       tr_seri(i,k,id_scdu)=tr_seri(i,k,id_scdu)+
+     s  sed_dustsco3D(i,k)*time_step
+      ENDDO
+      ENDDO
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+
+c
+       DO i=1, klon
+         sed_dustsco(i)=sed_flux(i,1)*1.e6*1.e3    !--unit mg/m2/s
+       ENDDO          !klon
+       ELSE
+        DO i=1, klon
+          sed_dustsco(i)=0.
+        ENDDO
+       ENDIF
+c
+
+
+
+
+c
+       RETURN
+       END
